#!/bin/bash

##############################################
# adapt these directories to you own needs:

export NXJ_HOME=/home/user/lejos/leJOS_NXJ_0.9.1beta-3
export LEJOS_NXT_JAVA_HOME=/usr
export PATH=/home/user/lejos/leJOS_NXJ_0.9.1beta-3/bin:$PATH

CDROM_DEVICE=/dev/sr1

cd /home/user/knowledgebase/lejos/diskCopy

if [ "$(whoami)" != "root" ];then
 echo "Please run this script as user root."
 exit 1
fi

# compile the program
if [ ! -e DVDChanger.class ];then
 nxjpcc DVDChanger.java
fi

logError () {
 echo "automateDiskCopy.sh: $1"
 logger "automateDiskCopy.sh: $1"
}

exitCloseTray () {
 # close the tray
 eject -t "$CDROM_DEVICE"
 exit 1
}

while [ true ]; do

 mountedDirectory="$(mount | grep "$CDROM_DEVICE" | sed 's|^[^ ]* on \(.*\) type .*|\1|g')"
 umount "$mountedDirectory"

 if [ $? -ne 0 ]; then
  logError "Unmounting failed."
  # exit 3
 fi

 eject "$CDROM_DEVICE"
 result=$?

 if [ $result -ne 0 ]; then
  logError "Could not eject drive, returned: $result."
  exit 1
 fi

 # wait for the drive
 sleep 1

 nxjpc DVDChanger removeInsert

 result=$?
 if [ $result -eq 1 ]; then
  logError "Bluetooth communication failed when removing disk."
  exitCloseTray
 fi
 if [ $result -eq 5 ]; then
  logError "Failed to remove disk. $index"
  sleep 1
  exitCloseTray
 fi
 if [ $result -eq 2 ]; then
  logError "There is still a disk inserted."
  exitCloseTray
 fi
 if [ $result -eq 3 ]; then
  logError "Failed to insert disk."
  exitCloseTray
 fi


 eject -t "$CDROM_DEVICE"
 result=$?

 if [ $result -ne 0 ]; then
  logError "eject -t not successful."
 fi

 # wait for the CD ROM to read the info and automount
 sleep 30

 # remount the device
 mount -o remount,ro "$CDROM_DEVICE"

 mountedDirectory="$(mount | grep "$CDROM_DEVICE" | sed 's|^[^ ]* on \(.*\) type .*|\1|g')"

 if [ $result -ne 0 ]; then
  logError "mount failed, returned: $result."
  umount "$CDROM_DEVICE"
 else

  # copy disk here
  # copy script should contain a sync at the end

  echo "Starting to copy"

 fi

done
